Redmine - Defect #7518

Mercurial diff can be wrong if the previous changeset isn't the parent
2011-02-02 05:08 - Toshi MARUYAMA

Status: Closed Start date: 2011-02-02
Priority: Normal Due date:

Assignee: Toshi MARUYAMA % Done: 0%
Category: SCM Estimated time: 0.00 hour
Target version: 1.2.0

Resolution: Fixed Affected version:

Description

Mercurial is DAG-based DVCS.

Before r4662, Redmine runs "hg diff -r 4661 -r 4662" for http://www.redmine.org/projects/redmine/repository/revisions/4662/diff .

If r4661 is not parent of r4662, diff is wrong.

This is TortoiseHg 1.9 image of Redmine 1.1 Mercurial test repository.

Parent of revision 16 is revision 6.

Graph | Rev | Node Branch Age
o 00000000000+ default 1 second ago
Q
I 15 933cab0293d7  branch (1)[2]&.%.-3_4 2002-01-01
14  24eaBB92elec branch (1)[2]&,%.-3_4 2002-01-01
13 33330eb32958 test-branch-00 1989-01-01
12 a072136d74b0 test-branch-00 1990-03-01
11 260ed5053c3a test-branch-00 1990-02-01
10 b7d10029dbb8  test-branch-00 1990-01-01
9 8293528deabc test-branch-00 20017-04-01
5] c51f5bb613cd test-branch-00 2001-02-01
7 3c3b3cBchabs test-branch-00 2000-017-01
? 5] 7fabbceB80d87 default 1970-01-01
Related issues:
Related to Redmine - Defect #3724: Mercurial repositories display revision ID... Closed 2009-08-10
Related to Redmine - Defect #7253: Test failures in MercurialAdapterTest Closed 2011-01-09
Related to Redmine - Defect #8741: Git: diff is always empty in merged revsion Closed 2011-07-03

Associated revisions

Revision 4792 - 2011-02-02 11:01 - Toshi MARUYAMA

scm: mercurial: add unit lib test for the previous changeset isn't the parent (#7253, #7518).

Revision 4853 - 2011-02-16 12:17 - Toshi MARUYAMA

scm: mercurial: add instance value flag of whether "hg diff -c" supports at tests (#7518).

Revision 4854 - 2011-02-16 12:17 - Toshi MARUYAMA

scm: mercurial: rewrite MercurialAdapter#diff by using helper extension (#4455, #7518).
fix incompatibility of diff with Mercurial < 1.1.

Contributed by Yuya Nishihara.

Revision 4855 - 2011-02-16 12:18 - Toshi MARUYAMA

scm: mercurial: set instance value flag of whether "hg diff -c" supports true at tests (#7518).

Revision 4859 - 2011-02-16 17:06 - Toshi MARUYAMA
scm: mercurial: fix Ruby 1.9 "hg diff" test fails (#7518).

History

#1 - 2011-02-07 05:07 - Toshi MARUYAMA
- Target version deleted (1.2.0)

#2 - 2011-02-18 03:29 - Toshi MARUYAMA
- Status changed from New to Closed
- Target version set to 1.2.0

- Resolution set to Fixed

Fixed by r4662 and r4854.

Mercurial can have two parents.
Diff for each parent is difficult in current Redmine interface.

Files

thg-graph.png

2025-05-01

24.9 KB

2011-02-02

Toshi MARUYAMA

22


https://www.redmine.org/projects/redmine/repository/svn/revisions/4662
https://www.redmine.org/projects/redmine/repository/svn/revisions/4854
http://www.tcpdf.org

